
#include <bits/stdc++.h>
using namespace std;
#define ll long long
vector<vector<int> > gr;
vector<vector<int> > gb;
vector<vector<int> > col;
int c = 0;
vector<int> color;
void dfs(const int v, vector<vector<int> > &g, const int x) {
    col[v][x] = c;
    for (auto u : g[v]) {
        if (col[u][x] == -1) {
            dfs(u, g, x);
        }
    }
}
int main() {
    int n, m;
    cin >> n >> m;
    if (n == 1) {
        string s;
        cin >> s;
        int q;
        cin >> q;
        while (q--) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            set<char> col;
            b--;
            d--;
            if (b > d) {
                swap(b, d);
            }
            for (int i = b; i < d; i++) {
                col.insert(s[i]);
            }
            cout << col.size() << endl;
        }
        return 0;
    }
    gb.resize(n * m);
    gr.resize(n * m);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m - 1; j++) {
            c = s[j];
            if (c == 'R') {
                gr[i * m + j].push_back(i * m + j + 1);
                gr[i * m + j + 1].push_back(i * m + j);
            } else {
                gb[i * m + j].push_back(i * m + j + 1);
                gb[i * m + j + 1].push_back(i * m + j);
            }
        }
    }
    for (int i = 0; i < n - 1; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            c = s[j];
            if (c == 'R') {
                gr[i * m + j].push_back((i + 1) * m + j);
                gr[(i + 1) * m + j].push_back(i * m + j);
            } else {
                gb[i * m + j].push_back((i + 1) * m + j + 1);
                gb[(i + 1) * m + j].push_back(i * m + j);
            }
        }
    }
    col.resize(n * m, vector<int>(2, -1));
    for (int i = 0; i < n * m; i++) {
        if (col[i][0] == -1) {
            c++;
            color.push_back(0);
            dfs(i, gr, 0);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col[i][1] == -1) {
            c++;
            color.push_back(1);
            dfs(i, gb, 1);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        int x = a * m + b;
        int y = c * m + d;
        if (col[x][0] == col[y][0] || col[x][1] == col[y][1]) {
            cout << 1 << endl;
        } else {
            cout << 2 << endl;
        }
    }
}
