#include <bits/stdc++.h>
using namespace std;
#define ll long long
vector<vector<int> > gr;
vector<vector<int> > gb;
vector<vector<int> > gg;
vector<vector<int> > go;
vector<vector<int> > col;
int c = 0;
vector<vector<int> > g;
void dfs(const int v, vector<vector<int> > &g, const int x) {
    col[v][x] = c;
    for (auto u: g[v]) {
        if (col[u][x] == -1) {
            dfs(u, g, x);
        }
    }
}
int bfs(int u, int v) {
    for (auto i : g[u]) {
        if (i == v) {
            return 1;
        }
        for (auto j : g[i]) {
            if (j == v) {
                return 2;
            }
            if (j == u) {
                continue;
            }
            for (auto k : g[j]) {
                if (k == v) {
                    return 3;
                }
            }
        }
    }
    return 4;
}
int main() {
    int n, m;
    cin >> n >> m;
    if (n == 1) {
        string s;
        cin >> s;
        int q;
        cin >> q;
        while (q--) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            set<char> col;
            b--;
            d--;
            if (b > d) {
                swap(b, d);
            }
            for (int i = b; i < d; i++) {
                col.insert(s[i]);
            }
            cout << col.size() << endl;
        }
        return 0;
    }
    gb.resize(n * m);
    gr.resize(n * m);
    go.resize(n * m);
    gg.resize(n * m);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m - 1; j++) {
            c = s[j];
            if (c == 'R') {
                gr[i * m + j].push_back(i * m + j + 1);
                gr[i * m + j + 1].push_back(i * m + j);
            } else if (c == 'B') {
                gb[i * m + j].push_back(i * m + j + 1);
                gb[i * m + j + 1].push_back(i * m + j);
            }else if (c == 'G') {
                gg[i * m + j].push_back(i * m + j + 1);
                gg[i * m + j + 1].push_back(i * m + j);
            } else {
                go[i * m + j].push_back(i * m + j + 1);
                go[i * m + j + 1].push_back(i * m + j);
            }
        }
    }
    for (int i = 0; i < n - 1; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            c = s[j];
            if (c == 'R') {
                gr[i * m + j].push_back((i + 1) * m + j);
                gr[(i + 1) * m + j].push_back(i * m + j);
            } else if (c == 'B'){
                gb[i * m + j].push_back((i + 1) * m + j);
                gb[(i + 1) * m + j].push_back(i * m + j);
            } else if (c == 'G'){
                gg[i * m + j].push_back((i + 1) * m + j);
                gg[(i + 1) * m + j].push_back(i * m + j);
            } else{
                go[i * m + j].push_back((i + 1) * m + j);
                go[(i + 1) * m + j].push_back(i * m + j);
            }
        }
    }
    c = 0;
    col.resize(n * m, vector<int>(4, -1));
    for (int i = 0; i < n * m; i++) {
        if (col[i][0] == -1) {
            c++;
            dfs(i, gr, 0);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col[i][1] == -1) {
            c++;
            dfs(i, gb, 1);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col[i][2] == -1) {
            c++;
            dfs(i, gg, 2);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col[i][3] == -1) {
            c++;
            dfs(i, go, 3);
        }
    }
    g.resize(c);
    for (int i = 0; i < n * m; i++) {
        for (auto u : col[i]) {
            for (auto v : col[i]) {
                if (u == v) {
                    continue;
                }
                g[u - 1].push_back(v - 1);
                g[v - 1].push_back(u - 1);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        int x = a * m + b;
        int y = c * m + d;
        int ans = 4;
        for (auto u : col[x]) {
            for (auto v : col[y]) {
                ans = min(ans, bfs(u, v));
            }
        }
        cout << ans << endl;
    }
}
