#include <bits/stdc++.h>
using namespace std;
#define ll long long
vector<int> dp;
constexpr long long x = 1000000009;
map<pair<ll, ll>, ll> m;
vector<ll> fa(301);
vector<ll> fr(301);
ll p(ll n, ll m) {
    if (m == 1) {
        return n % x;
    }
    if (m % 2 == 0) {
        ll s = p(n, m / 2);
        s %= x;
        s *= s;
        s %= x;
        return s;
    }
    ll s = p(n, m - 1);
    s %= x;
    s *= n;
    s %= x;
    return s;
}

ll f(ll n, ll k) {
    if (n % 2 != 0) {
        return 0;
    }
    if (n == 0 && k == 0) {
        return 1ll;
    }
    if (k == 0) {
        return 0;
    }
    if (n < 2 * k) {
        return 0;
    }
    if (n == 2 * k) {
        return 1ll;
    }
    if (m.count({n, k}) != 0) {
        return m[{n, k}] % x;
    }
    ll ans = 0;
    for (int i = 2; i < n; i += 2) {
        ll s = 0;
        for (int j = 0; j <= k; j++) {
            s += f(n - i, j);
            s %= x;
        }
        s *= f(i, k);
        s %= x;
        ans += s;
        ans %= x;
    }
    ans *= 2;
    ans %= x;
    ll s = f(n / 2, k) % x;
    s *= s;
    s %= x;
    ans -= s;
    ans %= x;
    ans += f(n - 2, k - 1);
    ans %= x;
    m.insert({{n, k}, ans % x});
    return ans % x;
}

ll c(int n, int k) {
    ll s = fa[n] * fr[k];
    s %= x;
    s *= fr[n - k];
    s %= x;
    return s;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    vector<vector<ll> > dp(21, vector<ll>(21, 0));
    fa[0] = 1;
    for (int i = 1; i < 301; i++) {
        fa[i] = fa[i - 1] * i;
        fa[i] %= x;
    }
    for (int i = 0; i < 301; i++) {
        fr[i] = p(fa[i], x - 2);
    }
    for (int n = 1; n <= 20; n++) {
        for (int k = 0; k <= n; k++) {
            ll ans = 0;
            for (int i = 2 * k; i <= n; i += 2) {
                ll s = f(i, k) * c(n, i);
                s %= x;
                ans += s;
                ans %= x;
            }
            ans %= x;
            dp[n][k] = ans;
        }
    }
    int n, k;
    cin >> n >> k;
    cout << dp[n][k];
}
