#include <bits/stdc++.h>
using namespace std;
#define ll long long
vector<int> dp;
ll x = 1000000009;
map<pair<ll, ll>, ll> m;
vector<ll> fa(301);
vector<ll> fr(301);
ll p(ll n, ll m) {
    if (m == 1) {
        return n % x;
    }
    if (m % 2 == 0) {
        ll s = p(n, m / 2);
        s %= x;
        s *= s;
        s %= x;
        return s;
    }
    ll s = p(n, m - 1);
    s %= x;
    s *= n;
    s %= x;
    return s;
}

ll f(ll n, ll k) {
    if (n % 2 != 0) {
        return 0;
    }
    if (n == 0 && k == 0) {
        return 1ll;
    }
    if (k == 0) {
        return 0;
    }
    if (n < 2 * k) {
        return 0;
    }
    if (n == 2 * k) {
        return 1ll;
    }
    if (m.count({n, k}) != 0) {
        return m[{n, k}] % x;
    }
    ll ans = 0;
    for (int i = 2; i < n; i += 2) {
        ll s = 0;
        for (int j = 0; j <= k; j++) {
            s += f(n - i, j);
            s %= x;
        }
        s *= f(i, k);
        s %= x;
        ans += s;
        ans %= x;
    }
    ans *= 2;
    ans %= x;
    ll s = f(n / 2, k) % x;
    s *= s;
    s %= x;
    ans -= s;
    ans %= x;
    ans += f(n - 2, k - 1);
    ans %= x;
    m.insert({{n, k}, ans % x});
    return ans % x;
}

ll c(int n, int k) {
    ll s = fa[n] * fr[k];
    s %= x;
    s *= fr[n - k];
    s %= x;
    return s;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, k;
    cin >> n >> k;
    vector<vector<ll> > dp(n + 1, vector<ll>(k + 1, 0));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        dp[i][0] = 1ll;
        for (int j = 1; j <= k; j++) {
            for (int m = 2; m < i; m++) {
                for (int q = 0; q < j; q++) {
                    dp[i][j] += (dp[m - 2][k - 1] * dp[i - m][q]) % x;
                    dp[i][j] %= x;
                }
            }
            dp[i][j] *= 2;
            dp[i][j] %= x;
            for (int m = 2; m <= i; m++) {
                dp[i][j] += (dp[m - 2][k - 1] * dp[i - m][k]) % x;
                dp[i][j] %= x;
            }
            if (i >= 2) {
                dp[i][j] += dp[i - 2][j - 1];
                dp[i][j] += dp[i - 2][j];
            }
            dp[i][j] %= x;
        }
    }
    cout << dp[n][k];
}
