#include <bits/stdc++.h>
using namespace std;
#define ll long long
vector<vector<int> > gr;
vector<vector<int> > gb;
vector<vector<int> > gg;
vector<vector<int> > go;
vector<vector<int> > col1;
vector<vector<int> > col2;
vector<vector<int> > col3;
int c = 0;
vector<set<int> > g;
void dfs1(const int v, vector<vector<int> > &g, const int x) {
    col1[v][x] = c;
    for (auto u: g[v]) {
        if (col1[u][x] == -1) {
            dfs1(u, g, x);
        }
    }
}
void dfs2(int v, vector<vector<int> > &g1, vector<vector<int> > &g2, int x) {
    col2[v][x] = c;
    for (auto u: g1[v]) {
        if (col2[u][x] == -1) {
            dfs2(u, g1, g2, x);
        }
    }
    for (auto u: g2[v]) {
        if (col2[u][x] == -1) {
            dfs2(u, g1, g2, x);
        }
    }
}
void dfs3(int v, vector<vector<int> > &g1, vector<vector<int> > &g2, vector<vector<int> > &g3, int x) {
    col3[v][x] = c;
    for (auto u: g1[v]) {
        if (col3[u][x] == -1) {
            dfs3(u, g1, g2, g3, x);
        }
    }
    for (auto u: g2[v]) {
        if (col3[u][x] == -1) {
            dfs3(u, g1, g2, g3, x);
        }
    }
    for (auto u: g3[v]) {
        if (col3[u][x] == -1) {
            dfs3(u, g1, g2, g3, x);
        }
    }
}
int bfs(int u, int v) {
    if (u == v) {
        return 1;
    }
    for (auto i : g[u]) {
        if (i == v) {
            return 2;
        }
        for (auto j : g[i]) {
            if (j == v) {
                return 3;
            }
        }
    }
    return 4;
}
int main() {
    int n, m;
    cin >> n >> m;
    if (n == 1) {
        string s;
        cin >> s;
        int q;
        cin >> q;
        while (q--) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            set<char> col;
            b--;
            d--;
            if (b > d) {
                swap(b, d);
            }
            for (int i = b; i < d; i++) {
                col.insert(s[i]);
            }
            cout << col.size() << endl;
        }
        return 0;
    }
    gb.resize(n * m);
    gr.resize(n * m);
    go.resize(n * m);
    gg.resize(n * m);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m - 1; j++) {
            c = s[j];
            if (c == 'R') {
                gr[i * m + j].push_back(i * m + j + 1);
                gr[i * m + j + 1].push_back(i * m + j);
            } else if (c == 'B') {
                gb[i * m + j].push_back(i * m + j + 1);
                gb[i * m + j + 1].push_back(i * m + j);
            }else if (c == 'G') {
                gg[i * m + j].push_back(i * m + j + 1);
                gg[i * m + j + 1].push_back(i * m + j);
            } else {
                go[i * m + j].push_back(i * m + j + 1);
                go[i * m + j + 1].push_back(i * m + j);
            }
        }
    }
    for (int i = 0; i < n - 1; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            c = s[j];
            if (c == 'R') {
                gr[i * m + j].push_back((i + 1) * m + j);
                gr[(i + 1) * m + j].push_back(i * m + j);
            } else if (c == 'B'){
                gb[i * m + j].push_back((i + 1) * m + j);
                gb[(i + 1) * m + j].push_back(i * m + j);
            } else if (c == 'G'){
                gg[i * m + j].push_back((i + 1) * m + j);
                gg[(i + 1) * m + j].push_back(i * m + j);
            } else{
                go[i * m + j].push_back((i + 1) * m + j);
                go[(i + 1) * m + j].push_back(i * m + j);
            }
        }
    }
    c = 0;
    col1.resize(n * m, vector<int>(4, -1));
    for (int i = 0; i < n * m; i++) {
        if (col1[i][0] == -1) {
            c++;
            dfs1(i, gr, 0);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col1[i][1] == -1) {
            c++;
            dfs1(i, gb, 1);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col1[i][2] == -1) {
            c++;
            dfs1(i, gg, 2);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col1[i][3] == -1) {
            c++;
            dfs1(i, go, 3);
        }
    }
    col2.resize(n * m, vector<int> (6, -1));
    for (int i = 0; i < n * m; i++) {
        if (col2[i][0] == -1) {
            c++;
            dfs2(i, gr, gb, 0);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col2[i][1] == -1) {
            c++;
            dfs2(i, gr, gg, 1);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col2[i][2] == -1) {
            c++;
            dfs2(i, gr, go, 2);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col2[i][3] == -1) {
            c++;
            dfs2(i, gb, gg, 3);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col2[i][4] == -1) {
            c++;
            dfs2(i, gb, go, 4);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col2[i][5] == -1) {
            c++;
            dfs2(i, gg, go, 5);
        }
    }
    col3.resize(n * m, vector<int>(4, -1));
    for (int i = 0; i < n * m; i++) {
        if (col3[i][0] == -1) {
            c++;
            dfs3(i, gb, gr, go, 0);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col3[i][1] == -1) {
            c++;
            dfs3(i, gb, gr, gg, 1);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col3[i][2] == -1) {
            c++;
            dfs3(i, gg, gr, go, 2);
        }
    }
    for (int i = 0; i < n * m; i++) {
        if (col3[i][3] == -1) {
            c++;
            dfs3(i, gb, gg, go, 3);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        int x = a * m + b;
        int y = c * m + d;
        int ans = 4;
        if (col1[x][0] == col1[y][0] || col1[x][1] == col1[y][1] || col1[x][2] == col1[y][2] || col1[x][3] == col1[y][3]) {
            cout << 1 << endl;
        } else if (col2[x][0] == col2[y][0] || col2[x][1] == col2[y][1] || col2[x][2] == col2[y][2] || col2[x][3] == col2[y][3] || col2[x][4] == col2[y][4] || col2[x][5] == col2[y][5]) {
            cout << 2 << endl;
        } else if (col3[x][0] == col3[y][0] || col3[x][1] == col3[y][1] || col3[x][2] == col3[y][2] || col3[x][3] == col2[y][3]) {
            cout << 3 << endl;
        } else {
            cout << 4 << endl;
        }
    }
}

